
log using OutOfSample.log, replace


* these results make use of new data for FRA & JPN, and pre-1945 revisions to DNK & DEU

clear
set mem 400m

*cd G:\moritzalancredit\
set more off

* get datasets
use panel15
sort iso year
merge iso year using RRBEKMlong
drop _merge
sort iso year
merge iso year using crisis_dates
drop _merge
sort iso year
merge iso year using stir_Jan10
drop _merge
gen stir2 = stir

sort iso year
merge iso year using stocks
drop _merge

rename crisisST crisisSTnew

* make crisis dates explicit // from ST paper appendix

gen crisisST = 0 
 replace crisisST = 1 if iso=="CHE" & year==1870
 replace crisisST = 1 if iso=="CAN" & year==1873
 replace crisisST = 1 if iso=="USA" & year==1873
 replace crisisST = 1 if iso=="SWE" & year==1876
 replace crisisST = 1 if iso=="DNK" & year==1877
 replace crisisST = 1 if iso=="DEU" & year==1880
 replace crisisST = 1 if iso=="USA" & year==1884
 replace crisisST = 1 if iso=="DNK" & year==1885
 replace crisisST = 1 if iso=="ITA" & year==1887
 replace crisisST = 1 if iso=="GBR" & year==1890
 replace crisisST = 1 if iso=="DEU" & year==1891
 replace crisisST = 1 if iso=="ITA" & year==1891
 replace crisisST = 1 if iso=="AUS" & year==1893
 replace crisisST = 1 if iso=="USA" & year==1893
 replace crisisST = 1 if iso=="NLD" & year==1897
 replace crisisST = 1 if iso=="SWE" & year==1897
 replace crisisST = 1 if iso=="NOR" & year==1899
 replace crisisST = 1 if iso=="DEU" & year==1901
 replace crisisST = 1 if iso=="DNK" & year==1902
 replace crisisST = 1 if iso=="CAN" & year==1906
 replace crisisST = 1 if iso=="DNK" & year==1907
 replace crisisST = 1 if iso=="ITA" & year==1907
 replace crisisST = 1 if iso=="SWE" & year==1907
 replace crisisST = 1 if iso=="USA" & year==1907
 replace crisisST = 1 if iso=="CHE" & year==1910
 replace crisisST = 1 if iso=="ESP" & year==1920
 replace crisisST = 1 if iso=="DNK" & year==1921
 replace crisisST = 1 if iso=="ITA" & year==1921
 replace crisisST = 1 if iso=="NLD" & year==1921
 replace crisisST = 1 if iso=="NOR" & year==1921
 replace crisisST = 1 if iso=="SWE" & year==1922
 replace crisisST = 1 if iso=="CAN" & year==1923
 replace crisisST = 1 if iso=="ESP" & year==1924
 replace crisisST = 1 if iso=="USA" & year==1929
 replace crisisST = 1 if iso=="ITA" & year==1930
 replace crisisST = 1 if iso=="CHE" & year==1931
 replace crisisST = 1 if iso=="DEU" & year==1931
 replace crisisST = 1 if iso=="DNK" & year==1931
 replace crisisST = 1 if iso=="ESP" & year==1931
 replace crisisST = 1 if iso=="NOR" & year==1931
 replace crisisST = 1 if iso=="SWE" & year==1931
 replace crisisST = 1 if iso=="ITA" & year==1935
 replace crisisST = 1 if iso=="NLD" & year==1939
 replace crisisST = 1 if iso=="GBR" & year==1974
 replace crisisST = 1 if iso=="ESP" & year==1978
*** delete this **** replace crisisST = 1 if iso=="CHE" & year==1980
 replace crisisST = 1 if iso=="CAN" & year==1983
 replace crisisST = 1 if iso=="GBR" & year==1984
 replace crisisST = 1 if iso=="USA" & year==1984
 replace crisisST = 1 if iso=="DNK" & year==1987
 replace crisisST = 1 if iso=="NOR" & year==1988
 replace crisisST = 1 if iso=="AUS" & year==1989
 replace crisisST = 1 if iso=="ITA" & year==1990
 replace crisisST = 1 if iso=="GBR" & year==1991
 replace crisisST = 1 if iso=="SWE" & year==1991
 
* now we add FRA & JPN crisis years (Moritz email jan 2010)
* FRA 1882, 1889, 1904, 1930, 2008??
* JPN 1882, 1907, 1927, 1992

 replace crisisST = 1 if iso=="FRA" & year==1882
 replace crisisST = 1 if iso=="FRA" & year==1889
 replace crisisST = 1 if iso=="FRA" & year==1904
 replace crisisST = 1 if iso=="FRA" & year==1930
 replace crisisST = 1 if iso=="FRA" & year==2008
 
 replace crisisST = 1 if iso=="JPN" & year==1882
 replace crisisST = 1 if iso=="JPN" & year==1907
 replace crisisST = 1 if iso=="JPN" & year==1927
 replace crisisST = 1 if iso=="JPN" & year==1992

* now we have to handle 07-08

  replace crisisST = 1 if iso=="GBR" & year==2007
 replace crisisST = 1 if iso=="USA" & year==2007
 
* the next are debatable
 replace crisisST = 1 if iso=="DEU" & year==2008
 replace crisisST = 1 if iso=="CHE" & year==2008
 replace crisisST = 1 if iso=="FRA" & year==2008
 replace crisisST = 1 if iso=="NLD" & year==2008
 replace crisisST = 1 if iso=="SWE" & year==2008
 replace crisisST = 1 if iso=="ESP" & year==2008
 replace crisisST = 1 if iso=="ITA" & year==2008


rename crisisST crisisSTold

gen crisisST=crisisSTnew



* now we have FRA data
*** no french data preww2, so ignore FRA
*** drop if iso=="FRA"
**%%%%%%%%% do not use noisy french loans data before 1895
replace loans1 = . if year<=1895 & iso=="FRA"


* make ccodes, sort, tsset
egen ccode = group(iso)
tab iso, gen(ccode)
sort ccode year
 xtset ccode year

* make some series
* loans1 = loans to private sector
gen loansgdp = loans1/gdp
gen credgdp = bassets2/gdp
gen moneygdp = money/gdp
gen loansmoney = loans1/money
gen credmoney= bassets2/money

gen lloansmoney = log(loansmoney)
gen lcredmoney = log(credmoney)


gen credimp = d.loans1/gdp

gen lev = loans1/money
gen dlev = d.lev
gen lm = log(money)
gen dlm = d.lm
gen dmgdp = d.money/gdp

gen lnm = log(narrowm)
gen dlnm = d.lnm

gen lloans = log(loans1)
gen dlloans = d.lloans
gen lassets = log(bassets2)
gen dlassets = d.lassets





sort ccode year
 xtset ccode year 


*********

* more series

gen lcred = log(bassets2)
gen dlcred = d.lcred

gen lcredm = log(bassets2/money)
gen lloansm = log(loans1/money)


gen pre45 = 1 if year<=1945
replace pre45 = 0 if year>1945

gen post45 = 1 if year>1945
replace post45 = 0 if year<=1945

gen era = "PostWW2" if year>1945
replace era = "PreWW2" if year<=1945

gen gtdep = 0
replace gtdep = 1 if year>1929 & year<1940

gen syear = year-1800
*graph bar lloansm lcredm , over(syear)

gen decade = year-ceil(year/10)*10
replace decade = . if decade~=0
replace decade = year if decade~=.

gen quinq = year-ceil(year/5)*5
replace quinq = . if quinq ~=0
replace quinq = year if quinq ~=.

gen yearx = string(year)
replace yearx = "" if quinq==.


* display crisis dates (check)

*list iso year if crisisST==1




gen sample = . if crisisST~=.
replace sample=0 if crisisST[_n]>=1 & crisisST[_n-1]==0
replace sample=1 if sample[_n-1]==0
replace sample=2 if sample[_n-1]==1
replace sample=3 if sample[_n-1]==2
replace sample=4 if sample[_n-1]==3
replace sample=5 if sample[_n-1]==4
replace sample = -1 if sample==.

* -1 is "normal"

*********

* more series

sort iso year
tsset ccode year, yearly


** wars

gen ww1 = 1 if year>=1914 & year<=1919
gen ww2 = 1 if year>=1939 & year<=1947
replace ww1 = 0 if ww1~=1
replace ww2 = 0 if ww2~=1

gen war=1 if ww1==1|ww2==1
replace war=0 if war~=1



gen sample2 = sample if ww1==0 & ww2==0
gen sample2s = string(sample2)
replace sample2s = " Normal " if sample2==-1
replace sample2s = "0" if sample2==0

gen securities = bassets2-loans1
gen cap1 = sec/bassets2*100
gen cap2 = govass/bassets2*100

gen lsec = log(securities)
gen lgovass = log(govass)
gen dlsec = d.lsec
gen dlgovass = d.lgovass
gen lgovbal = log(govass/bassets2)
gen lsecbal = log(sec/bassets2)

gen dlsecbal = dlsec-dlassets
gen dlgovbal = dlgovass-dlassets


sort iso year
tsset ccode year, yearly


gen lrgdp = log(rgdp)
gen dlrgdp = d.lrgdp
gen diy = d.iy

gen lpc = log(cpi)
gen dlpc = d.lpc

gen lcredr = lcred-lpc
gen lloansr = lloans-lpc
gen lmr= lm-lpc
gen lnarrowm = log(narrowm)
gen linvr  = ln(iy) + lrgdp
gen lmmult = lm-lnm
gen dlinvr = d.linvr


gen dlloansr = dlloans - dlpc


drop if war==1 | year>=2009 | year<=1870






***** in versus out of sample?


 logit crisisST ccode* l(1/5).dlloansr ,  vce(robust)
 predict tempin, xb
 replace tempin = . if year<1984

gen tempout = .
forvalues yr = 1984/2008  {
qui logit crisisST ccode* l(1/5).dlloansr  if year< `yr'
 predict temp, xb
 replace tempout = temp if year==`yr'
 drop temp
 }
 
 * roctab crisisST tempin 
 * roctab crisisST tempout
 
 roccomp crisisST tempin tempout
 
gen in_sample = tempin
gen out_of_sample = tempout

* roc for in and out of sample
 roccomp crisisST in_sample out_of_sample, graph scale(.8)
* graph save crisisrocinandout, replace

sum year if tempin~=. & tempout~=.

***** in versus out of sample? old


replace crisisST = crisisSTold

drop temp* in_* out_*

 logit crisisST ccode* l(1/5).dlloansr ,  vce(robust)
 predict tempin, xb
 replace tempin = . if year<1984

gen tempout = .
forvalues yr = 1984/2008  {
qui logit crisisST ccode* l(1/5).dlloansr  if year< `yr'
 predict temp, xb
 replace tempout = temp if year==`yr'
 drop temp
 }
 
 * roctab crisisST tempin 
 * roctab crisisST tempout
 
 roccomp crisisST tempin tempout
 
gen in_sample = tempin
gen out_of_sample = tempout

* roc for in and out of sample
 roccomp crisisST in_sample out_of_sample, graph scale(.8)
* graph save crisisrocinandout, replace

sum year if tempin~=. & tempout~=.


***** in versus out of sample? new except for old CANADA dates

drop temp* in_* out_*

replace crisisST = crisisSTnew

*! it is switching to the new CAN+NLD dates that seems to matter
*other changes do not make a significant difference (check AMT 3/31/11)
*
replace crisisST = crisisSTold if iso=="CAN" 
replace crisisST = crisisSTold if iso=="NLD" 


 logit crisisST ccode* l(1/5).dlloansr ,  vce(robust)
 predict tempin, xb
 replace tempin = . if year<1984

gen tempout = .
forvalues yr = 1984/2008  {
qui logit crisisST ccode* l(1/5).dlloansr  if year< `yr'
 predict temp, xb
 replace tempout = temp if year==`yr'
 drop temp
 }
 
 * roctab crisisST tempin 
 * roctab crisisST tempout
 
 roccomp crisisST tempin tempout
 
gen in_sample = tempin
gen out_of_sample = tempout

* roc for in and out of sample
 roccomp crisisST in_sample out_of_sample, graph scale(.8)
* graph save crisisrocinandout, replace

sum year if tempin~=. & tempout~=.


* stare at these
list iso year crisis* if (crisisSTnew==1 | crisisSTold==1) & (iso=="CAN"|iso=="NLD")


set more on
log close

